// Code generated by "enumer -type=GoOs -json -text -yaml -sql"; DO NOT EDIT.

package goos

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _GoOsName = "DarwinLinuxWindowsUnknown"

var _GoOsIndex = [...]uint8{0, 6, 11, 18, 25}

func (i GoOs) String() string {
	if i < 0 || i >= GoOs(len(_GoOsIndex)-1) {
		return fmt.Sprintf("GoOs(%d)", i)
	}
	return _GoOsName[_GoOsIndex[i]:_GoOsIndex[i+1]]
}

var _GoOsValues = []GoOs{0, 1, 2, 3}

var _GoOsNameToValueMap = map[string]GoOs{
	_GoOsName[0:6]:   0,
	_GoOsName[6:11]:  1,
	_GoOsName[11:18]: 2,
	_GoOsName[18:25]: 3,
}

// GoOsString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func GoOsString(s string) (GoOs, error) {
	if val, ok := _GoOsNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to GoOs values", s)
}

// GoOsValues returns all values of the enum
func GoOsValues() []GoOs {
	return _GoOsValues
}

// IsAGoOs returns "true" if the value is listed in the enum definition. "false" otherwise
func (i GoOs) IsAGoOs() bool {
	for _, v := range _GoOsValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for GoOs
func (i GoOs) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for GoOs
func (i *GoOs) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("GoOs should be a string, got %s", data)
	}

	var err error
	*i, err = GoOsString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for GoOs
func (i GoOs) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for GoOs
func (i *GoOs) UnmarshalText(text []byte) error {
	var err error
	*i, err = GoOsString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for GoOs
func (i GoOs) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for GoOs
func (i *GoOs) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = GoOsString(s)
	return err
}

func (i GoOs) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *GoOs) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := GoOsString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
